%define anolis_release 3

%bcond_without selinux
%bcond_without check

Summary: GNU file archiving program
Name: tar
Epoch: 2
Version: 1.34
Release: %{anolis_release}%{?dist}
License: GPLv3+
URL: https://www.gnu.org/software/tar/

Source0: https://ftp.gnu.org/gnu/tar/tar-%{version}.tar.xz
Source1: https://ftp.gnu.org/gnu/tar/tar-%{version}.tar.xz.sig

Patch1:  tar-1.28-loneZeroWarning.patch
Patch2:  tar-1.28-vfatTruncate.patch
Patch3:  tar-1.29-wildcards.patch
Patch4:  tar-1.28-atime-rofs.patch
Patch9:  tar-1.28-document-exclude-mistakes.patch
Patch10: tar-1.33-fix-capabilities-test.patch
# https://git.savannah.gnu.org/cgit/tar.git/commit/?id=55f2a0772e08b9febac3ac0de5cb048d4c60d2f5
Patch11: Fix-unlikely-uninitalized-var-bug-with-sparse-file.patch
# https://git.savannah.gnu.org/cgit/tar.git/commit/?id=e5bc23efcc90700710f97379d3116febc5705e19
Patch12: Fix-the-use-of-options-with-trailing-slash-in-files-.patch
# https://git.savannah.gnu.org/cgit/tar.git/commit/?id=93082d6eb84a086b02c7a8607f2553d5d9d0a93c
Patch13: Fix-crash-on-invalid-command-line-argument.patch
# https://git.savannah.gnu.org/cgit/tar.git/commit/?id=193eb8f81d8fbf7b1f3bd2b93f60882e56325d72
Patch14: transform-fix-replacement-of-particular-pattern-inst.patch
# https://git.savannah.gnu.org/cgit/tar.git/commit/?id=cc8f5f78b2437f50f0972433275b910b10d46717
Patch15: Handle-invalid-sparse-entries-in-pax-header.patch
# https://git.savannah.gnu.org/cgit/tar.git/commit/?id=a339f05cd269013fa133d2f148d73f6f7d4247e4
Patch16: Fix-handling-of-extended-header-prefixes.patch
# https://git.savannah.gnu.org/cgit/tar.git/commit/?id=7958eb97e6ca2aca66c2d5a45b7e803f31646e4e
Patch17: Fix-null-rereference-if-low-memory.patch
# https://git.savannah.gnu.org/cgit/tar.git/commit/?id=79a442d7b0e92622794bfa41dee18a28e450a0dc
Patch18: tar-fix-race-condition-1.patch
# https://git.savannah.gnu.org/cgit/tar.git/commit/?id=79d1ac38c19faad64f0e993180bf1ad27f217072
Patch19: tar-fix-race-condition-2.patch
# https://git.savannah.gnu.org/cgit/tar.git/commit/?id=d935dc7d1c150b3425dd43dc13a4dd2e2b712c26
Patch20: Avoid-EOVERFLOW-problems-in-some-symlink-tests.patch
# https://git.savannah.gnu.org/cgit/tar.git/commit/?id=66be5a789e70f911170017754fc51e499998f90e
Patch21: Avoid-excess-lseek-etc.patch
# https://git.savannah.gnu.org/cgit/tar.git/commit/?id=0b74885e81b90d6ab4890b195dce99ca9109fe59
Patch22: Fix-bug-with-x-xattr-read-only-files.patch
# https://git.savannah.gnu.org/cgit/tar.git/commit/?id=f8e14746d2ca72804a4520c059d7bf65ca00c5ac
Patch23: Fix-delete-bug-with-short-reads.patch
# https://git.savannah.gnu.org/cgit/tar.git/commit/?id=bc277c7069cdebb6a6140326636555267b142e0e
Patch24: Fix-data-loss-when-acting-as-filter.patch
# https://git.savannah.gnu.org/cgit/tar.git/commit/?id=7324326b1df67831b39a597eb10f67a5369aa189
Patch25: tar-fix-exclude-vcs-ignores-memory.patch
# https://git.savannah.gnu.org/cgit/tar.git/commit/?id=02f9af1b8df67e55ceb19ea1465d210a2fa1f02c
Patch26: Fix-savannah-bug-63250.patch
# https://git.savannah.gnu.org/cgit/tar.git/commit/?id=17debecd7300e94f590b8ce167a8c0735cb6d57d
Patch27: Fix-savannah-bug-63123.patch
# https://git.savannah.gnu.org/cgit/tar.git/commit/?id=de64229632a333bca312df70fd58ca8970f10414
Patch28: Fix-undefined-behavior-on-bad-extended-header.patch
# https://git.savannah.gnu.org/cgit/tar.git/commit/?id=24c830696527566742f1c8cac70d53086afca599
Patch29: Fix-Af-F-bug-when-F-is-not-a-regular-file.patch
# https://git.savannah.gnu.org/cgit/tar.git/commit/?id=e89c7a45eba7644693870b613386baa45d624e6a
Patch30: Fix-savannah-bug-63567.patch
# https://git.savannah.gnu.org/cgit/tar.git/commit/?id=71d1619abd8de3d67105230a301264d0de86c0c7
Patch31: Fix-assume-include.patch

BuildRequires: make
BuildRequires:  gcc
BuildRequires: autoconf automake texinfo gettext libacl-devel

%if %{with check}
# cover needs of tar's testsuite
BuildRequires: attr acl policycoreutils
%endif

%if %{with selinux}
BuildRequires: libselinux-devel
%endif
Provides: bundled(gnulib)
Provides: bundled(paxutils)
Provides: /bin/tar
Provides: /bin/gtar

%description
The GNU tar program saves many files together in one archive and can
restore individual files (or all of the files) from that archive. Tar
can also be used to add supplemental files to an archive and to update
or list files in the archive. Tar includes multivolume support,
automatic archive compression/decompression, the ability to perform
remote archives, and the ability to perform incremental and full
backups.

If you want to use tar for remote backups, you also need to install
the rmt package on the remote box.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{epoch}:%{version}-%{release}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -p1
autoreconf -v

# Keep only entries related to the latest release.
mv ChangeLog{,~}
awk 'stop = false; /^2014-07-27/ { stop = true; exit }; { print }' \
    < ChangeLog~ > ChangeLog


%build
%configure \
    %{!?with_selinux:--without-selinux} \
    --with-lzma="xz --format=lzma" \
    DEFAULT_RMT_DIR=%{_sysconfdir} \
    RSH=/usr/bin/ssh

%make_build


%install
%make_install

ln -s tar $RPM_BUILD_ROOT%{_bindir}/gtar
rm -f $RPM_BUILD_ROOT/%{_infodir}/dir
mkdir -p $RPM_BUILD_ROOT%{_mandir}/man1
ln -s tar.1.gz $RPM_BUILD_ROOT%{_mandir}/man1/gtar.1

# XXX Nuke unpackaged files.
rm -f $RPM_BUILD_ROOT%{_sysconfdir}/rmt
rm -f $RPM_BUILD_ROOT%{_mandir}/man8/rmt.8*

%find_lang %name

%generate_compatibility_deps

%check
%if %{with check}
rm -f $RPM_BUILD_ROOT/test/testsuite
# make check TESTSUITEFLAGS='-k \!dirrem01,\!dirrem02' || (
make check || (
    # get the error log
    set +x
    find -name testsuite.log | while read line; do
        echo "=== $line ==="
        cat "$line"
        echo
    done
    false
)
%endif


%files -f %{name}.lang
%license COPYING
%dir %{abidir}
%{_bindir}/tar
%{_bindir}/gtar
%{abidir}/tar-option.list
%{_mandir}/man1/tar.1*
%{_mandir}/man1/gtar.1*
%{_infodir}/tar.info*

%files doc
%doc AUTHORS README THANKS NEWS ChangeLog

%changelog
* Tue Dec 06 2022 Shawn Wang <shawnwang@linux.alibaba.com> - 2:1.34-3
- add abi/api info
- add some patches

* Mon Oct 10 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 1.34-2
- add doc package

* Wed Mar 09 2022 Hongwei Qin <qhw01063182@alibaba-inc.com> - 1.34-1
- Rebase to version 1.34
- Init for Anolis OS 23
